/* Declare camsys.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_CAMSYS_H__



// signals file inclusion
#define __3DFC_CAMSYS_H__



class CCameraSystem {

public:

   CCameraSystem ();
   CCameraSystem ( CCameraSystem& oCS );
   ~CCameraSystem ();

public:

   INT m_anSin [ ROUND ];       // sin lockup table (fix point 16.16)
   INT m_anCos [ ROUND ];       // cos lockup table (fix point 16.16)
   float m_afSin [ ROUND ];     // sin lockup table (floating point)
   float m_afCos [ ROUND ];     // cos lockup table (floating point)

   // reference system base in fix point 16.16
   tagXYZ m_stFixI;  // the vetor I of reference system base (fix point)
   tagXYZ m_stFixJ;  // the vetor J of reference system base (fix point)
   tagXYZ m_stFixK;  // the vetor K of reference system base (fix point)
   // reference system base in floating point
   tagfXYZ m_stI;    // the vetor I of reference system base
   tagfXYZ m_stJ;    // the vetor J of reference system base
   tagfXYZ m_stK;    // the vetor K of reference system base
   // reference system origin
   tagfXYZ m_stPos;  // the position of SR in space
   //  projection center distance
   INT m_nDistCP;    // distance between the projection center and it's plane

   // the camera pysical data (put in other object class in future)
   float m_fRadius;     // camera radius
   float m_fSpeed;      // move speed

   void mCreate ();
   void mDestroy ();
   void mResetPos ();
   void mResetBase ();
   void mSetObj ( CCameraSystem& oCS );
   void operator = ( CCameraSystem& oCS );
   void mComputeFixPointBase ();
   void mTransform ( CCameraSystem& oC );

   // transformation
   void mApplyBase ( tagfXYZ& stPoint );
   void mRotate ( BYTE yAX, BYTE yAY, BYTE yAZ, float& fX, float& fY,
                                                                 float& fZ );
   void mRotateTransBase ( BYTE yAX, BYTE yAY, BYTE yAZ );
   void mRotateBase ( BYTE yAX, BYTE yAY, BYTE yAZ );
};



// end declarations
#endif
